#include "zsc_acs.h"

#include <ACS_ZDoom.h>
#include <stdio.h>
#include <stdbool.h>
#include <stdlib.h>

//
// acsPickActor
//
[[extern("ACS"), call("ScriptS")]]
int acsPickActor()
{
    return ACS_PickActor(
        ZSC_ARG_I(0),
        ZSC_ARG_A(1),
        ZSC_ARG_A(2),
        ZSC_ARG_F(3),
        ZSC_ARG_I(4),
        ZSC_ARG_I(5),
        ZSC_ARG_I(6),
        ZSC_ARG_I(7)
    );
}

//
// acsGetActorLightLevel
//
[[extern("ACS"), call("ScriptS")]]
fixed acsGetActorLightLevel()
{
    return ACS_GetActorLightLevel(ZSC_ARG_I(0));
}

//
// acsSetActorState
//
[[extern("ACS"), call("ScriptS")]]
void acsSetActorState()
{
    ACS_SetActorState(
        ZSC_ARG_I(0),
        ZSC_ARG_S(1),
        ZSC_ARG_I(2)
    );
}

//
// acsChangeLevel
//
[[extern("ACS"), call("ScriptS")]]
void acsChangeLevel()
{
    ACS_ChangeLevel(
        ZSC_ARG_S(0),
        ZSC_ARG_I(1),
        ZSC_ARG_I(2),
        ZSC_ARG_I(3)
    );
}

//
// zslibStrToInt
//
[[extern("ACS"), call("ScriptS")]]
int zslibStrToInt()
{
    return strtol_str(ZSC_ARG_S(0), NULL, 10);
}

//
// zslibStrToFixed
//
[[extern("ACS"), call("ScriptS")]]
fixed zslibStrToFixed()
{
    return strtof_str(ZSC_ARG_S(0), NULL);
}
