#ifndef __ZSC_ACS_H_
#define __ZSC_ACS_H_

#include <stdfix.h>

#define ZSC_ARG_I(x) (zsc_args[x].i)
#define ZSC_ARG_F(x) (zsc_args[x].f)
#define ZSC_ARG_S(x) (zsc_args[x].s)
#define ZSC_ARG_A(x) (ZSC_ARG_F(x) / 360.0k)
#define ZSC_RET_S(x) (zsc_ret.s = (x))

// Types ----------------------------------------------------------------------

typedef union zsc_arg_u
{
    int   i;
    fixed f;
    __str s;
} zsc_arg_t;


// Extern Objects -------------------------------------------------------------

extern zsc_arg_t zsc_args[];
extern zsc_arg_t zsc_ret;

#endif//__ZSC_ACS_H_
